#include "sourcet.h"
#include "globalt.h"
#include "globmatt.h"

sourcet::sourcet()
{
  //  type of model of source
  sourtype = (sourcetype) 0;
  
  //  general function
  gf=NULL;
  
  //  constant value for stationary problems only
  v = 0.0;
  
  
  //nmultpv = 0;
  //cemh = NULL;//zatim??
}

sourcet::~sourcet()
{
}

/**
   function reads input data
   
   @param in - pointer to input file
   
   JK, revised 25.6.2005
*/
long sourcet::read (XFILE *in)
{
  //char *files = new char[1000];
  
  switch (Tp->tprob){
  case stationary_problem:{
    xfscanf (in,"%lf",&v);
    break;
  }
  case nonstationary_problem:
  case nonlinear_nonstationary_problem:
  case discont_nonstat_problem:
  case discont_nonlin_nonstat_problem:
  case growing_np_problem:
  case growing_np_problem_nonlin:{
    //  type of model of source
    //  matfunction=1
    //  cement_hydration=5
    xfscanf (in,"%d",(int*)&sourtype);
    
    switch (sourtype){
    case matfunction:{
      gf = new gfunct;
      gf->read (in);
      break;
    }
    case cement_hydration:{
      //zatim??!!
      //cemh = new cemhyd (NULL);
      //getnexttxt (in);
      //inputln (in,files,1000);
      //cemh->read (files);
      break;
    }
    default:{
      print_err("unknown type of model of quantity source is required",__FILE__,__LINE__,__func__);
    }
    }
    
    break;
  }
  default:{
    print_err("unknown type of problem is required",__FILE__,__LINE__,__func__);
  }
  }
  
  return(0);
}

/**
   function prints output data
   
   @param out - pointer to output file
   
   TKr, 3.1.2006
*/
long sourcet::print(FILE *out)
{
  switch (Tp->tprob){
  case stationary_problem:{
    fprintf (out,"\n %lf ",v);
    break;
  }
  case nonstationary_problem:
  case nonlinear_nonstationary_problem:
  case discont_nonstat_problem:
  case discont_nonlin_nonstat_problem:
  case growing_np_problem:
  case growing_np_problem_nonlin:{
    //  type of model of source
    fprintf (out,"\n %d \n",sourtype);
    
    switch (sourtype){
    case matfunction:{
      gf->print (out);
      break;
    }
    case cement_hydration:{
      //cemh->print (out);
      break;
    }
    default:{
      print_err("unknown type of model of quantity source is required",__FILE__,__LINE__,__func__);
    }
    }
    
    break;
  }
  default:{
    print_err("unknown type of problem is required",__FILE__,__LINE__,__func__);
  }
  }
  
  return(0);
}

/**
   function returns value of source of quantity at required time
   
   @param eid - element id
   
   JK, revised 25.6.2005
*/
double sourcet::giveval (long eid)
{
  long i,ipp;
  double ret,t;
  
  switch (Tp->tprob){
  case stationary_problem:{
    ret=v;
    break;
  }
    
  case nonstationary_problem:
  case nonlinear_nonstationary_problem:
  case discont_nonstat_problem:
  case discont_nonlin_nonstat_problem:
  case growing_np_problem:
  case growing_np_problem_nonlin:{
    
    switch (sourtype){
    case matfunction:{
      t = Tp->time;
      ret = gf->getval (t);
      break;
    }
    case cement_hydration:{
      ipp=Tt->elements[eid].ipp[0][0];
      i = Tm->ip[ipp].idm;
      ret = Tm->cemhydr[i].get_source(ipp,0,0);
      break;
    }
    default:{
      print_err("unknown type of model of quantity source is required",__FILE__,__LINE__,__func__);
    }
    }
    
    break;
  }
  default:{
    print_err("unknown type of problem is required",__FILE__,__LINE__,__func__);
  }
  }
  
  return(ret);
}


long sourcet::read_prop(FILE *in, long lc)
{
  /*
  fscanf(in, "%ld", &nlc);
  if ((nlc < 1) || (nlc > lc))
    return(2);
  fscanf(in, "%le", &f);
  xfscanf(in, "%255s", func);
  //fgets(func, 255, in);
  */
  return(0);
}
